net.sf.jasperreports.engine.fill

## Class JRBaseFiller

- java.lang.Object
- - net.sf.jasperreports.engine.fill.JRBaseFiller

- All Implemented Interfaces:
    JRDefaultStyleProvider
  Direct Known Subclasses:
    JRHorizontalFiller, JRVerticalFiller

      public abstract class JRBaseFiller
      extends java.lang.Object
      implements JRDefaultStyleProvider

  Version:
    $Id: JRBaseFiller.java 7011 2014-04-10 14:38:11Z lucianc $
  Author:
    Teodor Danciu (teodord@users.sourceforge.net)

- - ### Nested Class Summary

    Nested Classes
    Modifier and Type | Class and Description
    --- | ---
    `protected static interface` | `JRBaseFiller.DefaultStyleListener`

  - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `protected JRFillBand` | `background`
    `protected java.util.List<JRBand>` | `bands` List of `JRFillBand` objects containing all bands of the report.
    `protected BookmarkHelper` | `bookmarkHelper`
    `protected int` | `bottomMargin`
    `protected java.util.HashMap<JREvaluationTime,java.util.LinkedHashMap<net.sf.jasperreports.engine.fill.PageKey,LinkedMap<java.lang.Object,net.sf.jasperreports.engine.fill.EvaluationBoundAction>>>` | `boundElements` Bound element maps indexed by `JREvaluationTime` objects.
    `protected JRCalculator` | `calculator`
    `protected int` | `columnCount`
    `protected RunDirectionEnum` | `columnDirection`
    `protected JRFillBand` | `columnFooter`
    `protected int` | `columnFooterOffsetY`
    `protected JRFillBand` | `columnHeader`
    `protected int` | `columnHeaderOffsetY`
    `protected int` | `columnIndex`
    `protected int` | `columnSpacing`
    `protected int` | `columnWidth`
    `protected java.util.Map<java.lang.String,JRFillDataset>` | `datasetMap` Map of datasets (`JRFillDataset` objects} indexed by name.
    `protected java.util.Map<java.lang.String,java.text.Format>` | `dateFormatCache`
    `protected JRStyle` | `defaultStyle`
    `protected JRFillSection` | `detailSection`
    `protected JRFillContext` | `fillContext`
    `protected java.util.Map<java.lang.Integer,JRFillElement>` | `fillElements`
    `protected int` | `fillerId`
    `protected FormatFactory` | `formatFactory`
    `protected JRFillGroup[]` | `groups`
    `protected boolean` | `isCreatingNewPage`
    `protected boolean` | `isFirstColumnBand`
    `protected boolean` | `isFirstPageBand`
    `protected boolean` | `isFloatColumnFooter`
    `protected boolean` | `isLastPageFooter`
    `protected boolean` | `isNewColumn`
    `protected boolean` | `isNewGroup`
    `protected boolean` | `isNewPage`
    `protected boolean` | `isSummaryNewPage`
    `protected boolean` | `isSummaryWithPageHeaderAndFooter`
    `protected boolean` | `isTitleNewPage`
    `protected JasperPrint` | `jasperPrint`
    `protected JasperReport` | `jasperReport` The report.
    `protected net.sf.jasperreports.engine.fill.SavePoint` | `keepTogetherSavePoint`
    `protected int` | `lastPageColumnFooterOffsetY`
    `protected JRFillBand` | `lastPageFooter`
    `protected int` | `leftMargin`
    `protected JRFillDataset` | `mainDataset` Main report dataset.
    `protected JRFillBand` | `missingFillBand`
    `protected JRFillSection` | `missingFillSection`
    `protected java.lang.String` | `name`
    `protected JRFillBand` | `noData`
    `protected java.util.Map<java.lang.String,java.text.Format>` | `numberFormatCache`
    `protected int` | `offsetX`
    `protected int` | `offsetY`
    `protected OrientationEnum` | `orientation`
    `protected JRFillBand` | `pageFooter`
    `protected JRFillBand` | `pageHeader`
    `protected int` | `pageHeight`
    `protected int` | `pageWidth`
    `protected JRFillSubreport` | `parentElement`
    `protected JRBaseFiller` | `parentFiller`
    `protected PrintOrderEnum` | `printOrder`
    `protected JRPrintPage` | `printPage`
    `protected int` | `printPageStretchHeight`
    `protected JRFillReportTemplate[]` | `reportTemplates`
    `protected int` | `rightMargin`
    `protected JRAbstractScriptlet` | `scriptlet`
    `protected JRStyle[]` | `styles`
    `protected java.util.Map<java.lang.Integer,JRBaseFiller>` | `subfillers` Collection of subfillers
    `protected JRFillBand` | `summary`
    `protected java.util.List<JRTemplate>` | `templates`
    `protected JRFillBand` | `title`
    `protected int` | `topMargin`
    `protected JRVirtualizationContext` | `virtualizationContext`
    `protected net.sf.jasperreports.engine.fill.ElementEvaluationVirtualizationListener` | `virtualizationListener`
    `protected WhenNoDataTypeEnum` | `whenNoDataType`
    `protected WhenResourceMissingTypeEnum` | `whenResourceMissingType` the resource missing handling type

  - ### Constructor Summary

    Constructors
    Modifier | Constructor and Description
    --- | ---
    `protected` | `JRBaseFiller(JasperReportsContext jasperReportsContext, JasperReport jasperReport, DatasetExpressionEvaluator initEvaluator, JRFillSubreport parentElement)`
    `protected` | `JRBaseFiller(JasperReportsContext jasperReportsContext, JasperReport jasperReport, JREvaluator initEvaluator, JRFillSubreport parentElement)`

  - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `protected void` | `addBoundElement(JRFillElement element, JRPrintElement printElement, EvaluationTimeEnum evaluationType, JRGroup group, JRFillBand band)`
    `protected void` | `addBoundElement(JRFillElement element, JRPrintElement printElement, EvaluationTimeEnum evaluationType, java.lang.String groupName, JRFillBand band)`
    `protected void` | `addBoundElement(JRFillElement element, JRPrintElement printElement, JREvaluationTime evaluationTime)`
    `protected void` | `addDefaultStyleListener(JRBaseFiller.DefaultStyleListener listener)`
    `void` | `addFillListener(FillListener fillListener)` Adds a fill lister to be notified by events that occur during the fill.
    `protected void` | `addLastPageBookmarks()`
    `protected void` | `addPage(JRPrintPage page)`
    `void` | `addPrintStyle(JRStyle style)`
    `protected void` | `addVariableCalculationReq(java.lang.String variableName, CalculationEnum calculation)` Adds a variable calculation request.
    `protected net.sf.jasperreports.engine.fill.SavePoint` | `advanceSavePoint(net.sf.jasperreports.engine.fill.SavePoint savePoint, net.sf.jasperreports.engine.fill.SavePoint newSavePoint)`
    `protected PrintElementOriginator` | `assignElementId(JRFillElement fillElement)`
    `void` | `cancelFill()` Cancells the fill process.
    `protected void` | `checkInterrupted()`
    `protected void` | `collectIncludedTemplates(JRTemplate template, java.util.List<JRStyle> externalStyles, java.util.Set<java.lang.String> loadedLocations, java.util.Set<java.lang.String> templateParentLocations)`
    `protected java.util.List<JRStyle>` | `collectStyles()`
    `protected void` | `collectStyles(JRTemplate template, java.util.List<JRStyle> externalStyles, java.util.Set<java.lang.String> loadedLocations)`
    `protected void` | `collectStyles(JRTemplate template, java.util.List<JRStyle> externalStyles, java.util.Set<java.lang.String> loadedLocations, java.util.Set<java.lang.String> templateParentLocations)`
    `protected void` | `collectTemplates()`
    `protected java.util.List<JRStyle>` | `collectTemplateStyles()`
    `protected void` | `createReportTemplates(JRFillObjectFactory factory)`
    `protected java.lang.Object` | `evaluateExpression(JRExpression expression, byte evaluation)` Evaluates an expression
    `JasperPrint` | `fill(java.util.Map<java.lang.String,java.lang.Object> parameterValues)`
    `JasperPrint` | `fill(java.util.Map<java.lang.String,java.lang.Object> parameterValues, java.sql.Connection conn)`
    `JasperPrint` | `fill(java.util.Map<java.lang.String,java.lang.Object> parameterValues, JRDataSource ds)`
    `protected abstract void` | `fillReport()`
    `protected JRPrintPage` | `getCurrentPage()`
    `int` | `getCurrentPageCount()` Returns the number of generated master print pages.
    `protected int` | `getCurrentPageStretchHeight()`
    `java.text.Format` | `getDateFormat(java.lang.String pattern)`
    `protected java.text.Format` | `getDateFormat(java.lang.String pattern, java.util.TimeZone timeZone)`
    `JRStyle` | `getDefaultStyle()` Returns a default style.
    `protected JRFillExpressionEvaluator` | `getExpressionEvaluator()`
    `protected JRFillField` | `getField(java.lang.String fieldName)` Returns a report field.
    `protected java.util.Map<java.lang.String,JRFillField>` | `getFieldsMap()` Returns the report fields indexed by name.
    `JRFillContext` | `getFillContext()`
    `protected int` | `getFillerId()`
    `protected FormatFactory` | `getFormatFactory()` Returns the report format factory.
    `protected JRFillGroup` | `getGroup(java.lang.String groupName)`
    `JasperPrint` | `getJasperPrint()`
    `JasperReport` | `getJasperReport()` Returns the report.
    `JasperReportsContext` | `getJasperReportsContext()`
    `protected java.util.Locale` | `getLocale()` Returns the report locale.
    `JRFillDataset` | `getMainDataset()`
    `protected int` | `getMasterColumnCount()`
    `JRBaseFiller` | `getMasterFiller()` Returns the top-level (master) filler object.
    `java.text.Format` | `getNumberFormat(java.lang.String pattern)`
    `protected java.util.Map<java.lang.String,JRFillParameter>` | `getParametersMap()` Returns the report parameters indexed by name.
    `java.lang.Object` | `getParameterValue(java.lang.String parameterName)` Returns the value of a parameter.
    `java.util.Map<java.lang.String,java.lang.Object>` | `getParameterValuesMap()` Returns the map of parameter values.
    `protected java.util.List<java.lang.String>` | `getPrintTransferPropertyPrefixes()`
    `JRPropertiesUtil` | `getPropertiesUtil()`
    `protected java.util.ResourceBundle` | `getResourceBundle()` Returns the report resource bundle.
    `JRStyledTextParser` | `getStyledTextParser()`
    `java.util.List<JRTemplate>` | `getTemplates()`
    `protected java.util.TimeZone` | `getTimeZone()` Returns the report time zone.
    `protected JRFillVariable` | `getVariable(java.lang.String variableName)` Returns a report variable.
    `protected java.util.Map<java.lang.String,JRFillVariable>` | `getVariablesMap()` Returns the report variables indexed by name.
    `java.lang.Object` | `getVariableValue(java.lang.String variableName)` Returns the value of a variable.
    `protected WhenResourceMissingTypeEnum` | `getWhenResourceMissingType()`
    `protected boolean` | `hasBoundActions(JRPrintPage page)`
    `protected boolean` | `hasMasterFormatFactory()`
    `protected boolean` | `hasMasterLocale()`
    `protected boolean` | `hasMasterTimeZone()`
    `protected void` | `initVirtualizationContext(java.util.Map<java.lang.String,java.lang.Object> parameterValues)`
    `protected boolean` | `isBandOverFlowAllowed()`
    `protected boolean` | `isInterrupted()`
    `protected boolean` | `isMasterReport()`
    `protected boolean` | `isPageFinal(int pageIdx)`
    `protected boolean` | `isSubreport()`
    `protected boolean` | `isSubreportRunToBottom()`
    `protected void` | `loadStyles()`
    `protected void` | `lockVirtualizationContext()`
    `protected void` | `lookupExternalDefaultStyle(java.util.Collection<JRStyle> styleList)`
    `protected void` | `moveBoundActions(net.sf.jasperreports.engine.fill.PageKey subreportKey, net.sf.jasperreports.engine.fill.PageKey parentKey)`
    `protected boolean` | `moveKeepTogetherSavePointContent()`
    `protected JRPrintPage` | `newPage()`
    `protected boolean` | `next()`
    `protected void` | `registerSubfiller(JRBaseFiller subfiller)`
    `protected void` | `resolveBandBoundElements(JRFillBand band, byte evaluation)` Resloves elements which are to be evaluated at band level.
    `protected void` | `resolveBoundElements(JREvaluationTime evaluationTime, byte evaluation)`
    `protected void` | `resolveColumnBoundElements(byte evaluation)` Resolves elements which are to be evaluated at column level.
    `protected void` | `resolveGroupBoundElements(byte evaluation, boolean isFinal)` Resolves elements which are to be evaluated at group level.
    `protected void` | `resolvePageBoundElements(byte evaluation)` Resolves elements which are to be evaluated at page level.
    `protected void` | `resolveReportBoundElements()` Resolves elements which are to be evaluated at report level.
    `protected void` | `setBandOverFlowAllowed(boolean splittableBand)`
    `protected void` | `setConnectionParameterValue(java.util.Map<java.lang.String,java.lang.Object> parameterValues, java.sql.Connection conn)`
    `protected void` | `setDatasourceParameterValue(java.util.Map<java.lang.String,java.lang.Object> parameterValues, JRDataSource ds)`
    `protected void` | `setDefaultStyle(JRStyle style)`
    `protected void` | `setInterrupted(boolean isInterrupted)`
    `protected void` | `setJasperReportsContext(JasperReportsContext jasperReportsContext)`
    `protected abstract void` | `setPageHeight(int pageHeight)`
    `protected void` | `setParameter(JRFillParameter parameter, java.lang.Object value)` Sets a parameter's value.
    `protected void` | `setParameter(java.lang.String parameterName, java.lang.Object value)` Sets a parameter's value.
    `protected void` | `setParameters(java.util.Map<java.lang.String,java.lang.Object> parameterValues)`
    `protected void` | `setSubreportRunner(JRSubreportRunner runner)`
    `protected void` | `setVirtualPageSize(java.util.Map<java.lang.String,java.lang.Object> parameterValues)`
    `protected void` | `subreportPageFilled(JRPrintPage subreportPage)`
    `protected void` | `suspendSubreportRunner()`
    `protected void` | `unlockVirtualizationContext()`
    `protected void` | `unregisterSubfiller(JRBaseFiller subfiller)`
    `protected void` | `updateBookmark(JRPrintElement element)`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Field Detail

    - #### fillElements

          protected final java.util.Map<java.lang.Integer,JRFillElement> fillElements

    - #### fillerId

          protected final int fillerId

    - #### parentFiller

          protected JRBaseFiller parentFiller

    - #### parentElement

          protected JRFillSubreport parentElement

    - #### name

          protected java.lang.String name

    - #### columnCount

          protected int columnCount

    - #### printOrder

          protected PrintOrderEnum printOrder

    - #### columnDirection

          protected RunDirectionEnum columnDirection

    - #### pageWidth

          protected int pageWidth

    - #### pageHeight

          protected int pageHeight

    - #### orientation

          protected OrientationEnum orientation

    - #### whenNoDataType

          protected WhenNoDataTypeEnum whenNoDataType

    - #### columnWidth

          protected int columnWidth

    - #### columnSpacing

          protected int columnSpacing

    - #### leftMargin

          protected int leftMargin

    - #### rightMargin

          protected int rightMargin

    - #### topMargin

          protected int topMargin

    - #### bottomMargin

          protected int bottomMargin

    - #### isTitleNewPage

          protected boolean isTitleNewPage

    - #### isSummaryNewPage

          protected boolean isSummaryNewPage

    - #### isSummaryWithPageHeaderAndFooter

          protected boolean isSummaryWithPageHeaderAndFooter

    - #### isFloatColumnFooter

          protected boolean isFloatColumnFooter

    - #### whenResourceMissingType

          protected WhenResourceMissingTypeEnum whenResourceMissingType

      the resource missing handling type

    - #### reportTemplates

          protected JRFillReportTemplate[] reportTemplates

    - #### templates

          protected java.util.List<JRTemplate> templates

    - #### defaultStyle

          protected JRStyle defaultStyle

    - #### styles

          protected JRStyle[] styles

    - #### mainDataset

          protected JRFillDataset mainDataset

      Main report dataset.

    - #### groups

          protected JRFillGroup[] groups

    - #### missingFillSection

          protected JRFillSection missingFillSection

    - #### missingFillBand

          protected JRFillBand missingFillBand

    - #### background

          protected JRFillBand background

    - #### title

          protected JRFillBand title

    - #### pageHeader

          protected JRFillBand pageHeader

    - #### columnHeader

          protected JRFillBand columnHeader

    - #### detailSection

          protected JRFillSection detailSection

    - #### columnFooter

          protected JRFillBand columnFooter

    - #### pageFooter

          protected JRFillBand pageFooter

    - #### lastPageFooter

          protected JRFillBand lastPageFooter

    - #### summary

          protected JRFillBand summary

    - #### noData

          protected JRFillBand noData

    - #### virtualizationContext

          protected JRVirtualizationContext virtualizationContext

    - #### virtualizationListener

          protected net.sf.jasperreports.engine.fill.ElementEvaluationVirtualizationListener virtualizationListener

    - #### formatFactory

          protected FormatFactory formatFactory

    - #### fillContext

          protected JRFillContext fillContext

    - #### boundElements

          protected java.util.HashMap<JREvaluationTime,java.util.LinkedHashMap<net.sf.jasperreports.engine.fill.PageKey,LinkedMap<java.lang.Object,net.sf.jasperreports.engine.fill.EvaluationBoundAction>>> boundElements

      Bound element maps indexed by `JREvaluationTime` objects.

    - #### jasperPrint

          protected JasperPrint jasperPrint

    - #### printPage

          protected JRPrintPage printPage

    - #### bookmarkHelper

          protected BookmarkHelper bookmarkHelper

    - #### printPageStretchHeight

          protected int printPageStretchHeight

    - #### bands

          protected java.util.List<JRBand> bands

      List of `JRFillBand` objects containing all bands of the report.

    - #### subfillers

          protected java.util.Map<java.lang.Integer,JRBaseFiller> subfillers

      Collection of subfillers

    - #### calculator

          protected JRCalculator calculator

    - #### scriptlet

          protected JRAbstractScriptlet scriptlet

    - #### datasetMap

          protected java.util.Map<java.lang.String,JRFillDataset> datasetMap

      Map of datasets (`JRFillDataset` objects} indexed by name.

    - #### jasperReport

          protected JasperReport jasperReport

      The report.

    - #### dateFormatCache

          protected java.util.Map<java.lang.String,java.text.Format> dateFormatCache

    - #### numberFormatCache

          protected java.util.Map<java.lang.String,java.text.Format> numberFormatCache

    - #### keepTogetherSavePoint

          protected net.sf.jasperreports.engine.fill.SavePoint keepTogetherSavePoint

    - #### isCreatingNewPage

          protected boolean isCreatingNewPage

    - #### isNewPage

          protected boolean isNewPage

    - #### isNewColumn

          protected boolean isNewColumn

    - #### isNewGroup

          protected boolean isNewGroup

    - #### isFirstPageBand

          protected boolean isFirstPageBand

    - #### isFirstColumnBand

          protected boolean isFirstColumnBand

    - #### columnIndex

          protected int columnIndex

    - #### offsetX

          protected int offsetX

    - #### offsetY

          protected int offsetY

    - #### columnHeaderOffsetY

          protected int columnHeaderOffsetY

    - #### columnFooterOffsetY

          protected int columnFooterOffsetY

    - #### lastPageColumnFooterOffsetY

          protected int lastPageColumnFooterOffsetY

    - #### isLastPageFooter

          protected boolean isLastPageFooter

  - ### Constructor Detail

    - #### JRBaseFiller

          protected JRBaseFiller(JasperReportsContext jasperReportsContext,
                      JasperReport jasperReport,
                      JREvaluator initEvaluator,
                      JRFillSubreport parentElement)
                          throws JRException

      Throws:
        `JRException`

    - #### JRBaseFiller

          protected JRBaseFiller(JasperReportsContext jasperReportsContext,
                      JasperReport jasperReport,
                      DatasetExpressionEvaluator initEvaluator,
                      JRFillSubreport parentElement)
                          throws JRException

      Throws:
        `JRException`

  - ### Method Detail

    - #### getParametersMap

          protected java.util.Map<java.lang.String,JRFillParameter> getParametersMap()

      Returns the report parameters indexed by name.
      Returns:
        the report parameters map

    - #### getParameterValuesMap

          public java.util.Map<java.lang.String,java.lang.Object> getParameterValuesMap()

      Returns the map of parameter values.
      Returns:
        the map of parameter values

    - #### getFieldsMap

          protected java.util.Map<java.lang.String,JRFillField> getFieldsMap()

      Returns the report fields indexed by name.
      Returns:
        the report fields map

    - #### getVariablesMap

          protected java.util.Map<java.lang.String,JRFillVariable> getVariablesMap()

      Returns the report variables indexed by name.
      Returns:
        the report variables map

    - #### getVariable

          protected JRFillVariable getVariable(java.lang.String variableName)

      Returns a report variable.
      Parameters:
        `variableName` - the variable name
      Returns:
        the variable

    - #### getField

          protected JRFillField getField(java.lang.String fieldName)

      Returns a report field.
      Parameters:
        `fieldName` - the field name
      Returns:
        the field

    - #### getJasperReportsContext

          public JasperReportsContext getJasperReportsContext()

    - #### setJasperReportsContext

          protected void setJasperReportsContext(JasperReportsContext jasperReportsContext)

    - #### getPropertiesUtil

          public JRPropertiesUtil getPropertiesUtil()

    - #### getPrintTransferPropertyPrefixes

          protected java.util.List<java.lang.String> getPrintTransferPropertyPrefixes()

    - #### getStyledTextParser

          public JRStyledTextParser getStyledTextParser()

    - #### getJasperPrint

          public JasperPrint getJasperPrint()

    - #### getCurrentPageCount

          public int getCurrentPageCount()

      Returns the number of generated master print pages.
      Returns:
        the number of generated master print pages

    - #### getDefaultStyle

          public JRStyle getDefaultStyle()

      Description copied from interface: `JRDefaultStyleProvider`
      Returns a default style.
      Specified by:
        `getDefaultStyle` in interface `JRDefaultStyleProvider`

    - #### isSubreport

          protected boolean isSubreport()

    - #### isMasterReport

          protected boolean isMasterReport()

    - #### isSubreportRunToBottom

          protected boolean isSubreportRunToBottom()

    - #### isInterrupted

          protected boolean isInterrupted()

    - #### setInterrupted

          protected void setInterrupted(boolean isInterrupted)

    - #### checkInterrupted

          protected void checkInterrupted()

    - #### getCurrentPage

          protected JRPrintPage getCurrentPage()

    - #### getCurrentPageStretchHeight

          protected int getCurrentPageStretchHeight()

    - #### setPageHeight

          protected abstract void setPageHeight(int pageHeight)

    - #### addFillListener

          public void addFillListener(FillListener fillListener)

      Adds a fill lister to be notified by events that occur during the fill.
      Parameters:
        `fillListener` - the listener to add

    - #### fill

          public JasperPrint fill(java.util.Map<java.lang.String,java.lang.Object> parameterValues,
                         java.sql.Connection conn)
                           throws JRException

      Throws:
        `JRException`

    - #### setConnectionParameterValue

          protected void setConnectionParameterValue(java.util.Map<java.lang.String,java.lang.Object> parameterValues,
                                         java.sql.Connection conn)

    - #### fill

          public JasperPrint fill(java.util.Map<java.lang.String,java.lang.Object> parameterValues,
                         JRDataSource ds)
                           throws JRException

      Throws:
        `JRException`

    - #### setDatasourceParameterValue

          protected void setDatasourceParameterValue(java.util.Map<java.lang.String,java.lang.Object> parameterValues,
                                         JRDataSource ds)

    - #### fill

          public JasperPrint fill(java.util.Map<java.lang.String,java.lang.Object> parameterValues)
                           throws JRException

      Throws:
        `JRException`

    - #### addPrintStyle

          public void addPrintStyle(JRStyle style)
                             throws JRException

      Throws:
        `JRException`

    - #### addDefaultStyleListener

          protected void addDefaultStyleListener(JRBaseFiller.DefaultStyleListener listener)

    - #### setDefaultStyle

          protected void setDefaultStyle(JRStyle style)

    - #### loadStyles

          protected void loadStyles()
                             throws JRException

      Throws:
        `JRException`

    - #### collectStyles

          protected java.util.List<JRStyle> collectStyles()
                                                   throws JRException

      Throws:
        `JRException`

    - #### collectTemplates

          protected void collectTemplates()
                                   throws JRException

      Throws:
        `JRException`

    - #### getTemplates

          public java.util.List<JRTemplate> getTemplates()

    - #### collectTemplateStyles

          protected java.util.List<JRStyle> collectTemplateStyles()
                                                           throws JRException

      Throws:
        `JRException`

    - #### collectStyles

          protected void collectStyles(JRTemplate template,
                           java.util.List<JRStyle> externalStyles,
                           java.util.Set<java.lang.String> loadedLocations)
                                throws JRException

      Throws:
        `JRException`

    - #### collectStyles

          protected void collectStyles(JRTemplate template,
                           java.util.List<JRStyle> externalStyles,
                           java.util.Set<java.lang.String> loadedLocations,
                           java.util.Set<java.lang.String> templateParentLocations)
                                throws JRException

      Throws:
        `JRException`

    - #### collectIncludedTemplates

          protected void collectIncludedTemplates(JRTemplate template,
                                      java.util.List<JRStyle> externalStyles,
                                      java.util.Set<java.lang.String> loadedLocations,
                                      java.util.Set<java.lang.String> templateParentLocations)
                                           throws JRException

      Throws:
        `JRException`

    - #### lookupExternalDefaultStyle

          protected void lookupExternalDefaultStyle(java.util.Collection<JRStyle> styleList)

    - #### fillReport

          protected abstract void fillReport()
                                      throws JRException

      Throws:
        `JRException`

    - #### setParameters

          protected void setParameters(java.util.Map<java.lang.String,java.lang.Object> parameterValues)
                                throws JRException

      Throws:
        `JRException`

    - #### initVirtualizationContext

          protected void initVirtualizationContext(java.util.Map<java.lang.String,java.lang.Object> parameterValues)

    - #### lockVirtualizationContext

          protected void lockVirtualizationContext()

    - #### unlockVirtualizationContext

          protected void unlockVirtualizationContext()

    - #### setVirtualPageSize

          protected void setVirtualPageSize(java.util.Map<java.lang.String,java.lang.Object> parameterValues)

    - #### getLocale

          protected java.util.Locale getLocale()

      Returns the report locale.
      Returns:
        the report locale

    - #### getTimeZone

          protected java.util.TimeZone getTimeZone()

      Returns the report time zone.
      Returns:
        the report time zone

    - #### getResourceBundle

          protected java.util.ResourceBundle getResourceBundle()

      Returns the report resource bundle.
      Returns:
        the report resource bundle

    - #### getFormatFactory

          protected FormatFactory getFormatFactory()

      Returns the report format factory.
      Returns:
        the report format factory

    - #### getDateFormat

          public java.text.Format getDateFormat(java.lang.String pattern)

    - #### getDateFormat

          protected java.text.Format getDateFormat(java.lang.String pattern,
                                       java.util.TimeZone timeZone)

    - #### getNumberFormat

          public java.text.Format getNumberFormat(java.lang.String pattern)

    - #### hasMasterFormatFactory

          protected boolean hasMasterFormatFactory()

    - #### hasMasterLocale

          protected boolean hasMasterLocale()

    - #### hasMasterTimeZone

          protected boolean hasMasterTimeZone()

    - #### setParameter

          protected void setParameter(java.lang.String parameterName,
                          java.lang.Object value)
                               throws JRException

      Sets a parameter's value.
      Parameters:
        `parameterName` - the parameter name
        `value` - the value
      Throws:
        `JRException`

    - #### setParameter

          protected void setParameter(JRFillParameter parameter,
                          java.lang.Object value)
                               throws JRException

      Sets a parameter's value.
      Parameters:
        `parameter` - the parameter
        `value` - the value
      Throws:
        `JRException`

    - #### next

          protected boolean next()
                          throws JRException

      Throws:
        `JRException`

    - #### resolveBoundElements

          protected void resolveBoundElements(JREvaluationTime evaluationTime,
                                  byte evaluation)
                                       throws JRException

      Throws:
        `JRException`

    - #### resolveReportBoundElements

          protected void resolveReportBoundElements()
                                             throws JRException

      Resolves elements which are to be evaluated at report level.
      Throws:
        `JRException`

    - #### resolvePageBoundElements

          protected void resolvePageBoundElements(byte evaluation)
                                           throws JRException

      Resolves elements which are to be evaluated at page level.
      Parameters:
        `evaluation` - the evaluation type
      Throws:
        `JRException`

    - #### resolveColumnBoundElements

          protected void resolveColumnBoundElements(byte evaluation)
                                             throws JRException

      Resolves elements which are to be evaluated at column level.
      Parameters:
        `evaluation` - the evaluation type
      Throws:
        `JRException`

    - #### resolveGroupBoundElements

          protected void resolveGroupBoundElements(byte evaluation,
                                       boolean isFinal)
                                            throws JRException

      Resolves elements which are to be evaluated at group level.
      Parameters:
        `evaluation` - the evaluation type
        `isFinal` -
      Throws:
        `JRException`

    - #### newPage

          protected JRPrintPage newPage()

    - #### getVariableValue

          public java.lang.Object getVariableValue(java.lang.String variableName)

      Returns the value of a variable.
      Parameters:
        `variableName` - the variable name
      Returns:
        the variable value
      Throws:
        `JRRuntimeException` - when the variable does not exist

    - #### getParameterValue

          public java.lang.Object getParameterValue(java.lang.String parameterName)

      Returns the value of a parameter.
      Parameters:
        `parameterName` - the parameter name
      Returns:
        the parameter value

    - #### resolveBandBoundElements

          protected void resolveBandBoundElements(JRFillBand band,
                                      byte evaluation)
                                           throws JRException

      Resloves elements which are to be evaluated at band level.
      Parameters:
        `band` - the band
        `evaluation` - the evaluation type
      Throws:
        `JRException`

    - #### addVariableCalculationReq

          protected void addVariableCalculationReq(java.lang.String variableName,
                                       CalculationEnum calculation)

      Adds a variable calculation request.
      Parameters:
        `variableName` - the variable name
        `calculation` - the calculation type

    - #### cancelFill

          public void cancelFill()
                          throws JRException

      Cancells the fill process.
      Throws:
        `JRException`

    - #### registerSubfiller

          protected void registerSubfiller(JRBaseFiller subfiller)

    - #### unregisterSubfiller

          protected void unregisterSubfiller(JRBaseFiller subfiller)

    - #### addPage

          protected void addPage(JRPrintPage page)

    - #### addLastPageBookmarks

          protected void addLastPageBookmarks()

    - #### updateBookmark

          protected void updateBookmark(JRPrintElement element)

    - #### evaluateExpression

          protected java.lang.Object evaluateExpression(JRExpression expression,
                                            byte evaluation)
                                                 throws JRException

      Evaluates an expression
      Parameters:
        `expression` - the expression
        `evaluation` - the evaluation type
      Returns:
        the evaluation result
      Throws:
        `JRException`

    - #### getExpressionEvaluator

          protected JRFillExpressionEvaluator getExpressionEvaluator()

    - #### getWhenResourceMissingType

          protected WhenResourceMissingTypeEnum getWhenResourceMissingType()

    - #### getJasperReport

          public JasperReport getJasperReport()

      Returns the report.
      Returns:
        the report

    - #### isBandOverFlowAllowed

          protected boolean isBandOverFlowAllowed()

    - #### setBandOverFlowAllowed

          protected void setBandOverFlowAllowed(boolean splittableBand)

    - #### getMasterColumnCount

          protected int getMasterColumnCount()

    - #### getMasterFiller

          public JRBaseFiller getMasterFiller()

      Returns the top-level (master) filler object.
      Returns:
        the master filler object

    - #### getMainDataset

          public JRFillDataset getMainDataset()

    - #### addBoundElement

          protected void addBoundElement(JRFillElement element,
                             JRPrintElement printElement,
                             EvaluationTimeEnum evaluationType,
                             java.lang.String groupName,
                             JRFillBand band)

    - #### addBoundElement

          protected void addBoundElement(JRFillElement element,
                             JRPrintElement printElement,
                             EvaluationTimeEnum evaluationType,
                             JRGroup group,
                             JRFillBand band)

    - #### addBoundElement

          protected void addBoundElement(JRFillElement element,
                             JRPrintElement printElement,
                             JREvaluationTime evaluationTime)

    - #### subreportPageFilled

          protected void subreportPageFilled(JRPrintPage subreportPage)

    - #### moveBoundActions

          protected void moveBoundActions(net.sf.jasperreports.engine.fill.PageKey subreportKey,
                              net.sf.jasperreports.engine.fill.PageKey parentKey)

    - #### isPageFinal

          protected boolean isPageFinal(int pageIdx)

    - #### hasBoundActions

          protected boolean hasBoundActions(JRPrintPage page)

    - #### getGroup

          protected JRFillGroup getGroup(java.lang.String groupName)

    - #### setSubreportRunner

          protected void setSubreportRunner(JRSubreportRunner runner)

    - #### suspendSubreportRunner

          protected void suspendSubreportRunner()
                                         throws JRException

      Throws:
        `JRException`

    - #### createReportTemplates

          protected void createReportTemplates(JRFillObjectFactory factory)

    - #### advanceSavePoint

          protected net.sf.jasperreports.engine.fill.SavePoint advanceSavePoint(net.sf.jasperreports.engine.fill.SavePoint savePoint,
                                                                    net.sf.jasperreports.engine.fill.SavePoint newSavePoint)

    - #### moveKeepTogetherSavePointContent

          protected boolean moveKeepTogetherSavePointContent()

    - #### getFillContext

          public JRFillContext getFillContext()

    - #### getFillerId

          protected int getFillerId()

    - #### assignElementId

          protected PrintElementOriginator assignElementId(JRFillElement fillElement)

© 2001-2010 Jaspersoft Corporation www.jaspersoft.com